// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from hippo_msgs:msg/PoseStampedNumbered.idl
// generated code does not contain a copyright notice
#include "hippo_msgs/msg/detail/pose_stamped_numbered__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `position`
#include "geometry_msgs/msg/detail/point__functions.h"
// Member `orientation`
#include "geometry_msgs/msg/detail/quaternion__functions.h"

bool
hippo_msgs__msg__PoseStampedNumbered__init(hippo_msgs__msg__PoseStampedNumbered * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    hippo_msgs__msg__PoseStampedNumbered__fini(msg);
    return false;
  }
  // number
  // position
  if (!geometry_msgs__msg__Point__init(&msg->position)) {
    hippo_msgs__msg__PoseStampedNumbered__fini(msg);
    return false;
  }
  // orientation
  if (!geometry_msgs__msg__Quaternion__init(&msg->orientation)) {
    hippo_msgs__msg__PoseStampedNumbered__fini(msg);
    return false;
  }
  return true;
}

void
hippo_msgs__msg__PoseStampedNumbered__fini(hippo_msgs__msg__PoseStampedNumbered * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // number
  // position
  geometry_msgs__msg__Point__fini(&msg->position);
  // orientation
  geometry_msgs__msg__Quaternion__fini(&msg->orientation);
}

bool
hippo_msgs__msg__PoseStampedNumbered__are_equal(const hippo_msgs__msg__PoseStampedNumbered * lhs, const hippo_msgs__msg__PoseStampedNumbered * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // number
  if (lhs->number != rhs->number) {
    return false;
  }
  // position
  if (!geometry_msgs__msg__Point__are_equal(
      &(lhs->position), &(rhs->position)))
  {
    return false;
  }
  // orientation
  if (!geometry_msgs__msg__Quaternion__are_equal(
      &(lhs->orientation), &(rhs->orientation)))
  {
    return false;
  }
  return true;
}

bool
hippo_msgs__msg__PoseStampedNumbered__copy(
  const hippo_msgs__msg__PoseStampedNumbered * input,
  hippo_msgs__msg__PoseStampedNumbered * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // number
  output->number = input->number;
  // position
  if (!geometry_msgs__msg__Point__copy(
      &(input->position), &(output->position)))
  {
    return false;
  }
  // orientation
  if (!geometry_msgs__msg__Quaternion__copy(
      &(input->orientation), &(output->orientation)))
  {
    return false;
  }
  return true;
}

hippo_msgs__msg__PoseStampedNumbered *
hippo_msgs__msg__PoseStampedNumbered__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  hippo_msgs__msg__PoseStampedNumbered * msg = (hippo_msgs__msg__PoseStampedNumbered *)allocator.allocate(sizeof(hippo_msgs__msg__PoseStampedNumbered), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(hippo_msgs__msg__PoseStampedNumbered));
  bool success = hippo_msgs__msg__PoseStampedNumbered__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
hippo_msgs__msg__PoseStampedNumbered__destroy(hippo_msgs__msg__PoseStampedNumbered * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    hippo_msgs__msg__PoseStampedNumbered__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
hippo_msgs__msg__PoseStampedNumbered__Sequence__init(hippo_msgs__msg__PoseStampedNumbered__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  hippo_msgs__msg__PoseStampedNumbered * data = NULL;

  if (size) {
    data = (hippo_msgs__msg__PoseStampedNumbered *)allocator.zero_allocate(size, sizeof(hippo_msgs__msg__PoseStampedNumbered), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = hippo_msgs__msg__PoseStampedNumbered__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        hippo_msgs__msg__PoseStampedNumbered__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
hippo_msgs__msg__PoseStampedNumbered__Sequence__fini(hippo_msgs__msg__PoseStampedNumbered__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      hippo_msgs__msg__PoseStampedNumbered__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

hippo_msgs__msg__PoseStampedNumbered__Sequence *
hippo_msgs__msg__PoseStampedNumbered__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  hippo_msgs__msg__PoseStampedNumbered__Sequence * array = (hippo_msgs__msg__PoseStampedNumbered__Sequence *)allocator.allocate(sizeof(hippo_msgs__msg__PoseStampedNumbered__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = hippo_msgs__msg__PoseStampedNumbered__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
hippo_msgs__msg__PoseStampedNumbered__Sequence__destroy(hippo_msgs__msg__PoseStampedNumbered__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    hippo_msgs__msg__PoseStampedNumbered__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
hippo_msgs__msg__PoseStampedNumbered__Sequence__are_equal(const hippo_msgs__msg__PoseStampedNumbered__Sequence * lhs, const hippo_msgs__msg__PoseStampedNumbered__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!hippo_msgs__msg__PoseStampedNumbered__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
hippo_msgs__msg__PoseStampedNumbered__Sequence__copy(
  const hippo_msgs__msg__PoseStampedNumbered__Sequence * input,
  hippo_msgs__msg__PoseStampedNumbered__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(hippo_msgs__msg__PoseStampedNumbered);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    hippo_msgs__msg__PoseStampedNumbered * data =
      (hippo_msgs__msg__PoseStampedNumbered *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!hippo_msgs__msg__PoseStampedNumbered__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          hippo_msgs__msg__PoseStampedNumbered__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!hippo_msgs__msg__PoseStampedNumbered__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
