// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from hippo_msgs:msg/PoseStampedNumbered.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "hippo_msgs/msg/pose_stamped_numbered.hpp"


#ifndef HIPPO_MSGS__MSG__DETAIL__POSE_STAMPED_NUMBERED__STRUCT_HPP_
#define HIPPO_MSGS__MSG__DETAIL__POSE_STAMPED_NUMBERED__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'position'
#include "geometry_msgs/msg/detail/point__struct.hpp"
// Member 'orientation'
#include "geometry_msgs/msg/detail/quaternion__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__hippo_msgs__msg__PoseStampedNumbered __attribute__((deprecated))
#else
# define DEPRECATED__hippo_msgs__msg__PoseStampedNumbered __declspec(deprecated)
#endif

namespace hippo_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct PoseStampedNumbered_
{
  using Type = PoseStampedNumbered_<ContainerAllocator>;

  explicit PoseStampedNumbered_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init),
    position(_init),
    orientation(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->number = 0ul;
    }
  }

  explicit PoseStampedNumbered_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    position(_alloc, _init),
    orientation(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->number = 0ul;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _number_type =
    uint32_t;
  _number_type number;
  using _position_type =
    geometry_msgs::msg::Point_<ContainerAllocator>;
  _position_type position;
  using _orientation_type =
    geometry_msgs::msg::Quaternion_<ContainerAllocator>;
  _orientation_type orientation;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__number(
    const uint32_t & _arg)
  {
    this->number = _arg;
    return *this;
  }
  Type & set__position(
    const geometry_msgs::msg::Point_<ContainerAllocator> & _arg)
  {
    this->position = _arg;
    return *this;
  }
  Type & set__orientation(
    const geometry_msgs::msg::Quaternion_<ContainerAllocator> & _arg)
  {
    this->orientation = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    hippo_msgs::msg::PoseStampedNumbered_<ContainerAllocator> *;
  using ConstRawPtr =
    const hippo_msgs::msg::PoseStampedNumbered_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<hippo_msgs::msg::PoseStampedNumbered_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<hippo_msgs::msg::PoseStampedNumbered_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      hippo_msgs::msg::PoseStampedNumbered_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<hippo_msgs::msg::PoseStampedNumbered_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      hippo_msgs::msg::PoseStampedNumbered_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<hippo_msgs::msg::PoseStampedNumbered_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<hippo_msgs::msg::PoseStampedNumbered_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<hippo_msgs::msg::PoseStampedNumbered_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__hippo_msgs__msg__PoseStampedNumbered
    std::shared_ptr<hippo_msgs::msg::PoseStampedNumbered_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__hippo_msgs__msg__PoseStampedNumbered
    std::shared_ptr<hippo_msgs::msg::PoseStampedNumbered_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const PoseStampedNumbered_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->number != other.number) {
      return false;
    }
    if (this->position != other.position) {
      return false;
    }
    if (this->orientation != other.orientation) {
      return false;
    }
    return true;
  }
  bool operator!=(const PoseStampedNumbered_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct PoseStampedNumbered_

// alias to use template instance with default allocator
using PoseStampedNumbered =
  hippo_msgs::msg::PoseStampedNumbered_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace hippo_msgs

#endif  // HIPPO_MSGS__MSG__DETAIL__POSE_STAMPED_NUMBERED__STRUCT_HPP_
