// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from hippo_msgs:msg/PoseStampedNumbered.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "hippo_msgs/msg/pose_stamped_numbered.hpp"


#ifndef HIPPO_MSGS__MSG__DETAIL__POSE_STAMPED_NUMBERED__TRAITS_HPP_
#define HIPPO_MSGS__MSG__DETAIL__POSE_STAMPED_NUMBERED__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "hippo_msgs/msg/detail/pose_stamped_numbered__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'position'
#include "geometry_msgs/msg/detail/point__traits.hpp"
// Member 'orientation'
#include "geometry_msgs/msg/detail/quaternion__traits.hpp"

namespace hippo_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const PoseStampedNumbered & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: number
  {
    out << "number: ";
    rosidl_generator_traits::value_to_yaml(msg.number, out);
    out << ", ";
  }

  // member: position
  {
    out << "position: ";
    to_flow_style_yaml(msg.position, out);
    out << ", ";
  }

  // member: orientation
  {
    out << "orientation: ";
    to_flow_style_yaml(msg.orientation, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const PoseStampedNumbered & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: number
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "number: ";
    rosidl_generator_traits::value_to_yaml(msg.number, out);
    out << "\n";
  }

  // member: position
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "position:\n";
    to_block_style_yaml(msg.position, out, indentation + 2);
  }

  // member: orientation
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "orientation:\n";
    to_block_style_yaml(msg.orientation, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const PoseStampedNumbered & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace hippo_msgs

namespace rosidl_generator_traits
{

[[deprecated("use hippo_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const hippo_msgs::msg::PoseStampedNumbered & msg,
  std::ostream & out, size_t indentation = 0)
{
  hippo_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use hippo_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const hippo_msgs::msg::PoseStampedNumbered & msg)
{
  return hippo_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<hippo_msgs::msg::PoseStampedNumbered>()
{
  return "hippo_msgs::msg::PoseStampedNumbered";
}

template<>
inline const char * name<hippo_msgs::msg::PoseStampedNumbered>()
{
  return "hippo_msgs/msg/PoseStampedNumbered";
}

template<>
struct has_fixed_size<hippo_msgs::msg::PoseStampedNumbered>
  : std::integral_constant<bool, has_fixed_size<geometry_msgs::msg::Point>::value && has_fixed_size<geometry_msgs::msg::Quaternion>::value && has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<hippo_msgs::msg::PoseStampedNumbered>
  : std::integral_constant<bool, has_bounded_size<geometry_msgs::msg::Point>::value && has_bounded_size<geometry_msgs::msg::Quaternion>::value && has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<hippo_msgs::msg::PoseStampedNumbered>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // HIPPO_MSGS__MSG__DETAIL__POSE_STAMPED_NUMBERED__TRAITS_HPP_
